# Data-driven Mutation Analysis for Cyber-Physical Systems

This replicability package contains the source code of DaMAT and raw data used on the empirical evaluation section. We also include a tutorial for DaMAT based on the LibCSP library.

**Note:** we do not share case studies source code because of confidentiality agreements with our industry partners.

## DAMAT

The folder DAMAT is structured as follows:

* LICENSE.txt
* NOTICE.txt
* README.md
* damat-pipeline: this folder contains all the scripts of DaMAT's pipeline
* mutator: this folder contains the source code used by DaMAT to generate the Mutation API and the relative test cases.
 
 More information can be found in the README files contained in every folder.

## Fault models

The folder contains the mutation operators configured for each subject:

* ESAIL-ADCS-FM.csv
* ESAIL-GPS-FM.csv
* ESAIL-PDHU-FM.csv
* LIBP-FM.csv

## Empirical evaluation data

The folder Data is structured in sub-folders, each one representing a specific research question:

* Data/RQ1 contains:
	* DaMAT raw output
	* Mutation analysis results
	* Test suites shortcomings
	* Readme for replicability of results

* Data/RQ2 contains:
  * Equivalent and redundant mutants data
  * Readme 

* Data/RQ3 contains:
  * Average test cases execution times
  * Execution overhead results
  * Readme for replicability of results
  
  
## Tutorial

The folder `DAMAT-tutorial-libcsp` includes a tutorial of DaMAT applied to the LibCSP library. For more information please refer to the README inside the tutorial folder.
